//+------------------------------------------------------------------+
//|                                                       BBRSI2.mq4 |
//|                                   Copyleft  2010 Zakharov Vadim |
//|                                                   aka Yuritch    |
//+------------------------------------------------------------------+

// !         
//  Basketbull   8.6  !!!

#property  indicator_separate_window
#property indicator_buffers     3
#property indicator_color2      Orange
#property indicator_color3      Lime
#property indicator_width2      2
#property indicator_width3      0
#property indicator_level1      50
#property indicator_level2      70
#property indicator_level3      30
#property indicator_levelcolor  Gray

extern int  TF  = 0;
extern string  _=" ";
extern int     depth=1440;
int  period,basket,smooth,price,mode;
int i, j,limit;
double rsi[],rsima1[],rsima2[],tmp,weight_sum,weight;
string Pairs[];
bool Recalculate=true;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
IndicatorDigits(1);

      period=GlobalVariableGet("period");
      basket=GlobalVariableGet("num_pair");
      smooth=GlobalVariableGet("smooth");
      price= GlobalVariableGet("a_price");
      mode=GlobalVariableGet("mode");

      ArrayResize(Pairs,basket);
      
      SetIndexBuffer(0,rsi);
      SetIndexStyle(0,DRAW_NONE);
      SetIndexLabel(0,NULL);
      SetIndexBuffer(1,rsima1);
      SetIndexLabel(1,"Main");
      SetIndexStyle(1,DRAW_LINE,0,2);
      SetIndexBuffer(2,rsima2);
      SetIndexStyle(2,DRAW_LINE,0,0);
      SetIndexLabel(2,"Signal");     
      

   int pairs=FileOpen("bbpairs", FILE_CSV|FILE_READ);
   
   for (i=0;i<basket;i++)
      {
      if (FileIsEnding(pairs)) break;
      Pairs[i] = FileReadString(pairs);
      }
      FileClose(pairs);
      Recalculate=true;
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
{
   int    limit;
   int counted_bars=IndicatorCounted();
   
   if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 ) limit=depth;
   if ( counted_bars < 1 )
      for(int i=1;i<depth+smooth+period;i++) 
         {
         rsi[Bars-i]=0;    
         rsima1[Bars-i]=0;  
         rsima2[Bars-i]=0;    
         } 
   
   if (GlobalVariableGet("reset") !=0)
      {
       Recalculate=true;
       IndicatorShortName("  ");
       return(0);
      }
   
   if (GlobalVariableGet("reset") !=0)
      {
       if(!Recalculate) {IndicatorShortName("  "); return(0);}
       return(0);
      }
      IndicatorShortName("BBRSI2("+period+","+smooth+","+price+")");

   if (Recalculate)
      {
      limit=Bars-1;
      period=GlobalVariableGet("period");
      basket=GlobalVariableGet("num_pair");
      smooth=GlobalVariableGet("smooth");
      price= GlobalVariableGet("a_price");
      mode=GlobalVariableGet("mode");

      ArrayResize(Pairs,basket);
      
      int pairs=FileOpen("bbpairs", FILE_CSV|FILE_READ);
   
      for (i=0;i<basket;i++)
         {
         if (FileIsEnding(pairs)) break;
         Pairs[i] = FileReadString(pairs);
         }
         FileClose(pairs);
      limit=depth;
      }
   
   i=limit;
   while(i >= 0) 
      {
      tmp = 0.0;
      for(j = 0; j < basket; j++) 
         {
         if (StringLen(Pairs[j])==0) continue;
         tmp = tmp + iRSI(Pairs[j],TF,period,price,i);
         }
      rsi[i] = tmp/basket;
      i--;
      }
   ArraySetAsSeries(rsi,true);
     
   i=limit;
   while(i >= 0)   
      {
      rsima1[i]=iMAOnArray(rsi,0,smooth,0,mode,i);
      rsima2[i]=iMAOnArray(rsi,0,MathRound(smooth/2),0,mode,i);
      i--;
      }
   
   return(0);
}

